CR .( Altera .hex file format 16-bit ) CR
\ ==============================================================
\ todo
\ ==============================================================
\ 20070729 bee 16bit version
\ 20070720 bee move SAVEFILE to savefile.f
\ 20070311 bee rewrite and add vectored data address conversion
\          using PAD is ok with eforth, gforth and swiftforth
\ 20070326 bee make generic
\ delivered by Jeff Fox 6/4/05 bugfix 6/5/05 jf
\ file names changed for Altera 7/6/05 jr
\ added xor to output numbers & some style edits 7/10/05 jr
\ change input to romram.bin, directories 11/25/05 jr
\ rev7.6 02/27/06 jr changed template,
\                 noted that rom/ram memory image is used
\ rev7.7 04/25/06 jr changed file name to match quartus instance id
\ ==============================================================
\
\ Altera 16-bit .hex format
\   no spaces in the output, spaces here are for readability
\
\ :02 addr  00  ** **  cs <cr><lf> \ cs = 100h - (byte.sum mod 256)
\ ...                              \ data records: 17 bytes each
\ :02 00a9  00  00 00  55 <cr><lf> \ 2+a9=ab,          100-ab=55
\ :02 00aa  00  41 b5  5e <cr><lf> \ 2+aa+41+b5=(1)a2, 100-a2=5e
\ ...
\ :00 0000  01         ff <cr><lf> \ end record: 13 bytes
\
\ ==============================================================

DECIMAL

\ ==============================================================
\ extensions

\ : S+ ( ca1 u1  ca2 u2 -- ca1 u1+u2 ) \ concatenate strings
\   >R >R                 \ save second string
\   2DUP CHARS +          \ end of first string
\   R> SWAP R@ CHARS MOVE \ add second string
\   R> + ;

13 CONSTANT \r ( -- cr )
10 CONSTANT \n ( -- lf )
CREATE "CR ( -- ca )  \r C,  \n C,

\ ==============================================================
\ hex record format

: HEX[] ( -- ca ) PAD ; \ use pad as temp buffer

VARIABLE CSUM   \ accumulate checksum
VARIABLE 'TA@   \ execution vector

' ABORT 'TA@ !  \ default vector

: ## ( d -- d ) OVER CSUM +!  # # ;

: HEX16 ( i u -- ca u )
  BASE @ >R  HEX   0 CSUM ! \ save radix, output hex bytes, set csum=0
  HEX[] 0  2SWAP BOUNDS     \ source address and count
  ?DO  S" :" S+             \ header=:, 1 byte
    2 0 <# ## #> S+         \ count=02, 2 bytes
    I 0 <# ## ## #> S+      \ address=xxxx, 4 bytes
    0 0 <# ## #> S+         \ type of record=00, 2 bytes
    I   'TA@ @ EXECUTE      \ Host Target Address Conversion
      0 <# ## ## #> S+      \ data=xxxxxx, 4 bytes
    CSUM @ NEGATE           \ calculate checksum
      0 <# ## #> S+         \ checksum=xx, 2 bytes, reset csum=0
    "CR 2 S+                \ new line, 2 bytes ( total 17 each )
  LOOP
  S" :00000001FF" S+        \ last record, 11 bytes
  "CR 2 S+                  \ new line, 2 bytes ( total 13 )
  R> BASE ! ;               \ restore radix

\ ==============================================================

